//-----------------------------------------------------------------------------
// CSG Stone Bench
//-----------------------------------------------------------------------------

#include "shapes.inc"
                   
//Bevelled_Text(Font, String, Cuts, BevelAng, BevelDepth, Depth, Offset, UseMerge)
#declare Bench_Leg =  object { 
   Center_Object (
      union {
            object { Bevelled_Text("WINGDNG2.TTF", "a", 10 , 35, 0.05, 0.15, 0.00, 0) 
               scale z*1
               scale 1.35
               rotate y*90
               rotate -x*83
               translate -x*0.2
            }
            object { Bevelled_Text("WINGDNG2.TTF", "a", 10 , 35, 0.05, 0.15, 0.00, 0) 
               scale z*1
               scale 1.35
               rotate y*90
               rotate -x*83
               scale -x*1  // double-sided bevel
               translate x*0.2 
         }
         scale 1.01 
         rotate y*180
      },x+z
   )
}

#declare Bench_Ornaments1 = Center_Object (
   object{ Bevelled_Text("WINGDNG2.TTF", "bdbghdcghacg", 5, 35, 0.045, 0.1, 0.00, 0) 
      scale 0.39
   },x+z
) 
#declare Bench_Ornaments2 = Center_Object (
   object{ Bevelled_Text("WINGDNG2.TTF", "ghdc", 5, 35, 0.045, 0.1, 0.00, 0) 
      scale 0.39
   },x+z
) 

#declare Bench_Block = superellipsoid { <0.1, 0.1> scale 0.5 scale <5, 0.3, 2> }  
#declare Bench_Cutaways = union { 
   cylinder { <0,-2,0><0,2,0>, 0.04 translate <-0.15, 0, -0.25> }
   cylinder { <0,-2,0><0,2,0>, 0.04 translate < 0.00, 0, -0.25> }
   cylinder { <0,-2,0><0,2,0>, 0.04 translate < 0.15, 0, -0.25> }
}
#declare Bench_Column = difference { 
   superellipsoid { <0.1, 0.1> scale 0.5 scale <0.5, 1.5, 0.5> } 
   object { Bench_Cutaways }
   object { Bench_Cutaways rotate y*90 }
   object { Bench_Cutaways rotate y*-90 }
   object { Bench_Cutaways rotate y*180 }
}

#declare T_Bench = texture {
   pigment { granite scale 6 color_map { [0 rgb 0.5][1 rgb 0.7] } }
   normal {
      average
      normal_map {
         [0.5
            granite 0.75 scale 0.3
         ]
         [1
            granite 0.5 scale 3
         ]
         [1
            bozo
            scale 0.1
            turbulence 0.25
            normal_map {
               [0 granite 0.75 scale 0.5]
               [1 crackle 1 scale 0.75]
            }
         ]
      } 
   }
   finish { 
      specular 0.15 roughness 0.15 
      reflection {0, 0.5 fresnel on} conserve_energy 
   }
}           

#declare Bench = union { 
   // seat
   object { Bench_Block }
          
   // rear columns
   object { Bench_Column translate <-2, -0.75, 0.5> }
   object { Bench_Column translate < 2, -0.75, 0.5> }
   
   // front "legs"
   object { Bench_Leg translate <-2, -0.15, -0.5> }
   object { Bench_Leg translate < 2, -0.15, -0.5> }
          
   // base
   object { Bench_Block scale y*0.175 translate -y*1.5 }
   object { Bench_Block scale y*0.175 scale 0.975 translate -y*1.45 }
   object { Bench_Block scale y*0.175 scale 0.95 translate -y*1.4 }

   // ornaments 
   object { Bench_Ornaments1 translate <0, -0.12, -1.0> }
   object { Bench_Ornaments2 rotate -y*90 translate <2.5, -0.12, 0> }
   object { Bench_Ornaments1 translate <0, -0.12, 1.0> }
   object { Bench_Ornaments2 rotate -y*90 translate <-2.5, -0.12, 0> }
   
   texture { T_Bench }
   interior { ior 1.45 }
}
